
#include "mcc_generated_files/mcc.h"

#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdint.h>
#include <stdbool.h>

#include <xc.h>
#define SPI_RX_IN_PROGRESS 0x0

// Defines
#define LED_PIN1 PORTAbits.RA1 //led test

#define SW PORTBbits.RB7


#define CE_Pin LATCbits.LATC5 //set port as output
#define CSN_Pin LATAbits.LATA5 //set port as output
#define SCK_Pin LATCbits.LATC3 //set port as output
#define MISO_Pin PORTCbits.RC4 //set port as input
#define MOSI_Pin LATCbits.LATC2 //set port as output
#define IRQ_Pin PORTCbits.RC1

#define HIGH 1
#define LOW 0
#define NRF24
#define nrf24_ADDR_LEN 5
#define nrf24_CONFIG ((1<<EN_CRC)|(0<<CRCO))
#define NRF24_TRANSMISSON_OK 0
#define NRF24_MESSAGE_LOST 1

unsigned char writeSPIByte(unsigned char data);
void nrf_init();
void nrf_transmit();


void main(void)
{
    SYSTEM_Initialize();
    nrf_init();
    LED_PIN1 = 0;

    __delay_ms( 100 );

    while (1) 
    {
            if(SW == 0)
            {
                __delay_ms(10);
                if(SW == 0)
                {
                LED_PIN1 = 1;
                __delay_ms(100);

                nrf_transmit();
                }
            }
            LED_PIN1 = 0;
            __delay_ms(100);
    }
}


unsigned char writeSPIByte(unsigned char data)
{
  // Clear the Write Collision flag, to allow writing
    SSP1CON1bits.WCOL = 0;

    SSP1BUF = data;

    while(SSP1STATbits.BF == SPI_RX_IN_PROGRESS)
    {
    }

    return (SSP1BUF);
}


void nrf_init()
{
    unsigned char j;

    CE_Pin = LOW;
    __delay_ms( 1 );
    CSN_Pin = HIGH;
    __delay_ms( 100 );

    // PTX, CRC enabled, mask a couple of ints
    // change CONFIG to 0x0A for PWR_UP, PTX
    CSN_Pin = LOW;
    writeSPIByte(0x20);
    writeSPIByte(0x0A);
    CSN_Pin = HIGH;

    //disable auto-ack, RX mode
    //shouldn't have to do this, but it won't TX if you don't
    CSN_Pin = LOW;
    writeSPIByte(0x21);
    writeSPIByte(0x00);
    CSN_Pin = HIGH;

    //address width = 5
    CSN_Pin = LOW;
    writeSPIByte(0x23);
    writeSPIByte(0x03);
    CSN_Pin = HIGH;

    //data rate = 1MB
    CSN_Pin = LOW;
    writeSPIByte(0x26);
    writeSPIByte(0x06);
    CSN_Pin = HIGH;

    //4 byte payload
    CSN_Pin = LOW;
    writeSPIByte(0x31);
    writeSPIByte(0x04);
    CSN_Pin = HIGH;

    //auto retransmit off
    CSN_Pin = LOW;
    writeSPIByte(0x24);
    writeSPIByte(0x00);
    CSN_Pin = HIGH;

    //set channel 5, this is default but we did it anyway...
    CSN_Pin = LOW;
    writeSPIByte(0x25);
    writeSPIByte(0x05);
    CSN_Pin = HIGH;

    //set address , also default...
    //XXX 0x30 set TX address, not RX
    const char *addr = "serv1";
    CSN_Pin = LOW;
    writeSPIByte(0x30);
    for (j = 0; j < 5; j++){
        writeSPIByte(addr[j]);
    }
    CSN_Pin = HIGH;
}


void nrf_transmit()
{
    
    CSN_Pin = LOW;
    writeSPIByte(0xA0);
    writeSPIByte(0x34);
    writeSPIByte(0x33);
    writeSPIByte(0x32);
    writeSPIByte(0x31);
    CSN_Pin = HIGH;

    
    CE_Pin = HIGH;
    __delay_ms(1);
    CE_Pin = LOW;
}
